! gtdata_variable.f90 - gtool ѿμ³
! Copyright (C) GFD Dennou Club, 2000.  All rights reserved.

module gtdata_generic

    implicit none
    !
    ! ܳư
    !

    interface open

        ! 
        ! open(var, url, [writable], [err])  url Ǽ̤
        ! ѿ򳫤 var ˳Ǽ롣writable 򿿤˻ꤹ
        ! 񤭹߲ĤǳȤ롣ǥեȤ writable=.FALSE. Ǥ롣
        ! 顼ȯ err Ȥʤ롣err ͿʤХץߤ롣
        !
        subroutine GTVarOpen(var, url, writable, err)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(out):: var
            character(*), intent(in):: url
            logical, intent(in), optional:: writable
            logical, intent(out), optional:: err
        end subroutine
        
        !
        ! ˳줿ѿ source_var  ord ܤμˤѿ
        !  var ˳Ǽ롣 ord ϸߤϰϤ
        ! ˤʤäƤ (ѥȲƤˤФ
        ! Ǥ뤬count_compact ˿ꤹ
        ! ٤ƤμΤʤνˤʤ롣
        !
        ! ord == 0 ξѿΤٳϻȥ󥿤
        ! äʤǤ롣
        !
        subroutine GTVarOpenByDimOrd(var, source_var, dimord, &
            count_compact, err)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(out):: var
            type(GT_VARIABLE), intent(in):: source_var
            integer, intent(in):: dimord
            logical, intent(in), optional:: count_compact
            logical, intent(out), optional:: err
        end subroutine

    end interface

    interface create
        !
        ! °ѿ create
        !
        ! create(var, url, [dims], [xtype], [overwrite], [err]) 
        !  url ˼ dims äѿ򳫤
        ! Τ var ˳Ǽ롣 xtype ά "float" 
        ! ߤʤ롣¸ѿȤԤ뤬
        ! overwrite Ǥ³Ԥ롣
        ! dims ξά 0 ѿ̣롣
        !
        subroutine GTVarCreate(var, url, dims, xtype, long_name, overwrite, err)
            use gtdata_types, only: gt_variable
            type(gt_variable), intent(inout):: var
            character(len = *), intent(in):: url
            type(gt_variable), intent(in), optional:: dims(:)
            character(len = *), intent(in), optional:: xtype
            character(len = *), intent(in), optional:: long_name
            logical, intent(in), optional:: overwrite
            logical, intent(out), optional:: err
        end subroutine
        !
        ! Ωѿ create
        !
        ! Ĺ length μʬȤ򼡸Ȥѿ롣
        ! Ĺ length = 0 ѿϲĹǤ롣
        !
        subroutine GTVarCreateD(var, url, length, xtype, long_name, overwrite, err)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(inout):: var
            character(len = *), intent(in):: url
            integer, intent(in):: length
            character(len = *), intent(in), optional:: xtype
            character(len = *), intent(in), optional:: long_name
            logical, intent(in), optional:: overwrite
            logical, intent(out), optional:: err
        end subroutine
    end interface

    interface close
        subroutine GTVarClose(var, err)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(inout):: var
            logical, intent(out), optional:: err
        end subroutine
    end interface

    !
    ! --- °ط ---
    !

    interface attr_rewind
        subroutine GTVarAttrRewind(var)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(inout):: var
        end subroutine
    end interface

    interface attr_next
        subroutine GTVarAttrNext(var, name, end)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(inout):: var
            character(*), intent(out):: name
            logical, intent(out), optional:: end
        end subroutine
    end interface

    ! ɤ߼ϴؿ󥿡ե
    interface attr_true
        logical function GTVarAttrTrue(var, name, default)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(in):: var
            character(len = *), intent(in):: name
            logical, intent(in), optional:: default
        end function
    end interface

    interface get_attr

        ! ʸȤɤ߼ϸĹΤ˼롣
        ! °¸ߤʤ default ͤȤ

        subroutine GTVarGetAttrSC(var, name, value, default)
            use dc_string, only: VSTRING    
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(in):: var
            character(len = *), intent(in):: name
            type(VSTRING), intent(out):: value
            character(len = *), intent(in), optional:: default
        end subroutine

        ! character Ǽ̾ʸƱ͡
        ! ¦ѿĹ˹碌ڤΤơԤ
        ! °¸ߤʤ default ͤȤ

        subroutine GTVarGetAttrCC(var, name, value, default)
            use dc_string, only: VSTRING    
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(in):: var
            character(len = *), intent(in):: name
            character(len = *), intent(out):: value
            character(len = *), intent(in), optional:: default
        end subroutine

        ! ǼΤִñǽͤȤ졢ĤϼΤƤ롣

        subroutine GTVarGetAttrR(var, name, value, default)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(in):: var
            character(len = *), intent(in):: name
            real, intent(out):: value
            real, intent(in), optional:: default
        end subroutine

        subroutine GTVarGetAttrD(var, name, value, default)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(in):: var
            character(len = *), intent(in):: name
            double precision, intent(out):: value
            double precision, intent(in), optional:: default
        end subroutine

        subroutine GTVarGetAttrI(var, name, value, default)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(in):: var
            character(len = *), intent(in):: name
            integer, intent(out):: value
            integer, intent(in), optional:: default
        end subroutine

        ! ݥȤäƼϲǽʿΤդ롣

        subroutine GTVarGetAttrRP(var, name, value)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(in):: var
            character(len = *), intent(in):: name
            real, pointer:: value(:)
        end subroutine

        subroutine GTVarGetAttrDP(var, name, value)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(in):: var
            character(len = *), intent(in):: name
            double precision, pointer:: value(:)
        end subroutine

        subroutine GTVarGetAttrIP(var, name, value)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(in):: var
            character(len = *), intent(in):: name
            integer, pointer:: value(:)
        end subroutine

        ! integer , real ȤƼ
        ! °ĹޤäƤˤڤΤƤ졢
        ! °Ĺ­ʤ default  (ݥ󥿤Ȱ㤤ɬ) 롣

        subroutine GTVarGetAttrRA(var, name, value, default)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(in):: var
            character(len = *), intent(in):: name
            real, intent(out):: value(:)
            real, intent(in):: default
        end subroutine

        subroutine GTVarGetAttrDA(var, name, value, default)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(in):: var
            character(len = *), intent(in):: name
            double precision, intent(out):: value(:)
            double precision, intent(in):: default
        end subroutine

        subroutine GTVarGetAttrIA(var, name, value, default)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(in):: var
            character(len = *), intent(in):: name
            integer, intent(out):: value(:)
            integer, intent(in):: default
        end subroutine

    end interface

    interface put_attr

        subroutine GTVarPutAttrString(var, name, value, err)
            use dc_string, only: VSTRING    
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(inout):: var
            character(len = *), intent(in):: name
            type(VSTRING), intent(in):: value
            logical, intent(out), optional:: err
        end subroutine

        subroutine GTVarPutAttrChar(var, name, value, xtype, err)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(inout):: var
            character(len = *), intent(in):: name
            character(len = *), intent(in):: value
            character(len = *), intent(in), optional:: xtype
            logical, intent(out), optional:: err
        end subroutine

        subroutine GTVarPutAttrReal(var, name, value, err)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(inout):: var
            character(len = *), intent(in):: name
            real, intent(in):: value(:)
            real, intent(out), optional:: err
        end subroutine

        subroutine GTVarPutAttrDouble(var, name, value, err)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(inout):: var
            character(len = *), intent(in):: name
            double precision, intent(in):: value(:)
            real, intent(out), optional:: err
        end subroutine

        subroutine GTVarPutAttrInt(var, name, value, err)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(inout):: var
            character(len = *), intent(in):: name
            integer, intent(in):: value(:)
            real, intent(out), optional:: err
        end subroutine

        subroutine GTVarPutAttrLogical(var, name, value, err)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(inout):: var
            character(len = *), intent(in):: name
            logical, intent(in):: value
            real, intent(out), optional:: err
        end subroutine

    end interface

    interface del_attr
        subroutine GTVarDelAttr(var, name, err)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(inout):: var
            character(len = *), intent(in):: name
            logical, intent(out), optional:: err
        end subroutine
    end interface

    interface copy_attr

        subroutine GTVarCopyAttr(to, attrname, from, err)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(inout):: to
            character(len = *), intent(in):: attrname
            type(GT_VARIABLE), intent(in):: from
            logical, intent(out), optional:: err
        end subroutine

        subroutine gtvarcopyattrall(to, from, err)
            use gtdata_types, only: gt_variable
            type(gt_variable), intent(inout):: to
            type(gt_variable), intent(inout):: from
            logical, intent(out):: err
        end subroutine

    end interface

    !
    ! --- ط ---
    !

    ! ߤϰϤ礭 inquire(var, size=) ǼǤ

    interface slice

        ! ޤؼ
        ! compatible ꤹȤޤäƱ˻
        subroutine GTVarSliceAuto(var, compatible)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(inout):: var
            type(GT_VARIABLE), intent(in), optional:: compatible
        end subroutine

        ! ⤸Ĥˤ뤷
        subroutine GTVarSliceC(var, slicespec, err)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(inout):: var
            character(len = *), intent(in):: slicespec
	    logical, intent(out):: err
        end subroutine

        ! ꤷؼ
        subroutine GTVarSlice(var, dimord, start, count, stride)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(inout):: var
            integer, intent(in):: dimord
            integer, intent(in), optional:: start
            integer, intent(in), optional:: count
            integer, intent(in), optional:: stride
        end subroutine
    end interface

    interface get_slice

        ! ֤ꤷƼ
        subroutine GTVarGetSlice(var, dimord, start, count, stride, count_compact)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(in):: var
            integer, intent(in):: dimord
            integer, intent(out), optional:: start
            integer, intent(out), optional:: count
            integer, intent(out), optional:: stride
            logical, intent(in), optional:: count_compact
        end subroutine

        ! ˤĤư
        ! 餫 inquire(var, alldims) ݤ롣
        subroutine GTVarGetSliceAll(var, start, count, stride)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(in):: var
            integer, intent(out), optional:: start(:), count(:), stride(:)
        end subroutine

    end interface

    interface dimname_to_dimord
        integer function gtdim_name2ord(var, name)
            use gtdata_types, only: gt_variable
            type(gt_variable), intent(in):: var
            character(len = *), intent(in):: name
        end function
    end interface

    ! limit: ѴﵡǽΥåȥå
    !
    interface limit

        subroutine GTVarLimit(var, string, err)
            use gtdata_types, only: gt_variable
            type(gt_variable), intent(inout) :: var
            character(len = *), intent(in)   :: string
            logical, intent(out), optional   :: err
        end subroutine

        subroutine GTVarLimit_iiii(var, dimord, start, count, stride, err)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(inout):: var
            integer, intent(in)             :: dimord
            integer, intent(in) , optional  :: start, count, stride
            logical, intent(out), optional  :: err
        end subroutine

    end interface

    interface transform

        subroutine GTVarXformBinary(var1, var2, err)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(inout):: var1, var2
            logical, intent(out), optional:: err
        end subroutine

    end interface

    ! ŪѴǽ

    ! ѿϥɥ var  dimord ܤΰ֤˼
    ! dimvar ɲä롣dimord ܰʹߤμϰĸˤ롣
    ! ⤷ dimord  var ͭ礭 (ͭ + 1)
    ! Ϳ줿ΤȤߤʤ롣
    interface add_dim
        subroutine gtvaradddim(var, dimord, dimvar, err)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(in):: var
            type(GT_VARIABLE), intent(in):: dimvar
            integer, intent(in):: dimord
            logical, intent(out):: err
        end subroutine
    end interface

    ! ѿϥɥ뤫鼡ֽפ롣ºݤˤϡ
    ! бɽν̤򲼤ͭǥȤʤΤǡ
    ! Ϥ˻پϤʤ
    interface del_dim
        subroutine gtvardeldim(var, dimord, err)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(in):: var
            integer, intent(in):: dimord
            logical, intent(out):: err
        end subroutine
    end interface

    ! бɽν̤θ
    interface exch_dim
        subroutine gtvarexchdim(var, dimord1, dimord2, count_compact, err)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(in):: var
            integer, intent(in):: dimord1, dimord2
            logical, intent(in), optional:: count_compact
            logical, intent(out):: err
        end subroutine
    end interface

    !
    ! --- 䤤碌 ---
    !

    interface inquire

        subroutine GTVarInquire(var, growable, &
            & rank, alldims, allcount, size, &
            & xtype, name, url)
            use gtdata_types, only: gt_variable
            type(gt_variable), intent(in):: var
            ! ̾
            character(len=*), intent(out), optional:: xtype
            ! name ѿ̾κǾñ̤֤
            ! ե̾ޤޤʤץǤΰݾڤʤ
            character(len=*), intent(out), optional:: name
            ! url ϥե̾ΤĤѿ֤̾ץ
            ! դǤ롣
            character(len=*), intent(out), optional:: url
            ! ѥ()ʤ, ο
            integer, intent(out), optional:: rank
            ! ༡ޤdimord ˤϴŪˤȤ
            integer, intent(out), optional:: alldims
            ! ѿѿǤ硢֤顼ϥ
            integer, intent(out), optional:: allcount
            ! ѿΰ礭
            integer, intent(out), optional:: size
            ! ѿѿǤ硢ưĥǽݤ֤
            ! Ǥʤꡣ
            logical, intent(out), optional:: growable
        end subroutine

        subroutine GTVarInquire2(var, allcount)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(in):: var
            ! alldims ɬ
            integer, intent(out):: allcount(:)
        end subroutine

        subroutine GTVarInquireD(var, dimord, url, allcount)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(in):: var
            integer, intent(in):: dimord
            character(len=*), intent(out), optional:: url
            integer, intent(out), optional:: allcount
        end subroutine

        subroutine GTVarInquireA(var, attrname, xtype)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(in):: var
            character(len=*), intent(in):: attrname
            character(len=*), intent(out), optional:: xtype
        end subroutine
    end interface

    ! ʤѥƥ졼
    interface slice_next
        subroutine GTVarSliceNext(var, dimord, err, stat)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(in out):: var
            integer, intent(in), optional:: dimord
            logical, intent(out), optional:: err
            integer, intent(out), optional:: stat
        end subroutine
    end interface

    ! ƱȽ
    interface operator(.equivalent.)
        logical function gtvarequivalent(var1, var2)
            use gtdata_types, only: gt_variable
            type(gt_variable), intent(in):: var1, var2
        end function
    end interface

    !
    ! ===  ===
    !
    ! ---  ---
    !
    ! get(var, value, nvalue, [err])
    ! 1˸ߤϰϤ롣
    ! nvalue ѼԤĹǼʤФʤʤ
    ! ̾ GTVarGetReal Ѥ¿
    ! 뤳ȤǤ뤬ϰϤȤδطդɬס
    !
    ! get(var, value, [err])  13 Υݥ󥿤Ȥ롣
    ! ϰϤݥ󥿼˸ꤷݤ
    ! ֤ͤ̾ϤѤ뤳Ȥˤʤ
    !

    interface get

        subroutine GTVarGetReal(var, value, nvalue, err)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(inout):: var
            real, intent(out):: value(*)
            integer, intent(in):: nvalue
            logical, intent(out), optional:: err
        end subroutine

        subroutine GTVarGetReal1(var, value, err)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(inout):: var
            real, pointer:: value(:)
            logical, intent(out), optional:: err
        end subroutine

        subroutine GTVarGetReal2(var, value, err)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(inout):: var
            real, pointer:: value(:, :)
            logical, intent(out), optional:: err
        end subroutine

        subroutine GTVarGetReal3(var, value, err)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(inout):: var
            real, pointer:: value(:, :, :)
            logical, intent(out), optional:: err
        end subroutine

        subroutine GTVarGetDouble(var, value, nvalue, err)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(inout):: var
            double precision, intent(out):: value(*)
            integer, intent(in):: nvalue
            logical, intent(out), optional:: err
        end subroutine

        subroutine GTVarGetDouble1(var, value, err)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(inout):: var
            double precision, pointer:: value(:)
            logical, intent(out), optional:: err
        end subroutine

        subroutine GTVarGetDouble2(var, value, err)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(inout):: var
            double precision, pointer:: value(:, :)
            logical, intent(out), optional:: err
        end subroutine

        subroutine GTVarGetDouble3(var, value, err)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(inout):: var
            double precision, pointer:: value(:, :, :)
            logical, intent(out), optional:: err
        end subroutine

    end interface

    !
    ! ---  ---
    !
    ! ȤΤѿˤƤߤϤեˤƤߤнϤ
    !  put  get ĤƤ褦ʤΤǤޤȤˤ䤷Τ
    !  dc_string μ³̾Ѿ put_line ˤƤ

    interface put_line
        subroutine GTVarPutLine(var, err)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(inout):: var
            logical, intent(out), optional:: err
        end subroutine
    end interface

    !
    ! ---  ---
    !

    interface put

        subroutine GTVarPutReal(var, value, nvalue, err)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(inout):: var
            real, intent(in):: value(*)
            integer, intent(in):: nvalue
            logical, intent(out), optional:: err
        end subroutine

        subroutine GTVarPutReal1(var, value, err)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(inout):: var
            real, intent(in):: value(:)
            logical, intent(out), optional:: err
        end subroutine

        subroutine GTVarPutReal2(var, value, err)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(inout):: var
            real, intent(in):: value(:, :)
            logical, intent(out), optional:: err
        end subroutine

        subroutine GTVarPutReal3(var, value, err)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(inout):: var
            real, intent(in):: value(:, :, :)
            logical, intent(out), optional:: err
        end subroutine

        subroutine GTVarPutDouble(var, value, nvalue, err)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(inout):: var
            double precision, intent(in):: value(*)
            integer, intent(in):: nvalue
            logical, intent(out), optional:: err
        end subroutine

        subroutine GTVarPutDouble1(var, value, err)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(inout):: var
            double precision, intent(in):: value(:)
            logical, intent(out), optional:: err
        end subroutine

        subroutine GTVarPutDouble2(var, value, err)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(inout):: var
            double precision, intent(in):: value(:, :)
            logical, intent(out), optional:: err
        end subroutine

        subroutine GTVarPutDouble3(var, value, err)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(inout):: var
            double precision, intent(in):: value(:, :, :)
            logical, intent(out), optional:: err
        end subroutine

    end interface

    !
    ! === ѿȥեδط ===
    !

    interface GTVarSearch
        
        subroutine GTVarSearchInit(urlBase)
            character(len = *), intent(in):: urlBase
        end subroutine

        subroutine GTVarSearchNext(url, end)
            character(len = *), intent(out):: url
            logical, intent(out):: end
        end subroutine

    end interface        

    !
    ! === Τæи ===
    !
    ! SysDepAbort ƤӽФΤǡStoreError ƤǤϤʤʤ
    !

    interface
        subroutine GTVarSync(var, stat)
            use gtdata_types, only: GT_VARIABLE
            type(GT_VARIABLE), intent(inout), optional:: var
            integer, intent(out), optional:: stat
        end subroutine
    end interface


    !
    ! === 桼ƥƥ ===
    !
    ! gtdata ؤǽ񤫤줿饤֥ꡣ

    ! Create(var, url, copyfrom, [copyvalue], [overwrite], [err])
    ! ѿ copyfrom Ʊ°äѿ롣
    ! ɬפʤмѿʣ롣
    ! copyvalue 򿿤˻ꤹͤʣ롣
    !
    interface Create
        subroutine GTVarCreateCopyC(var, url, copyfrom, copyvalue, &
            & overwrite, err)
            use gtdata_types, only: GT_VARIABLE
            implicit none
            type(GT_VARIABLE), intent(out):: var
            character(len = *), intent(in):: url
            type(GT_VARIABLE), intent(inout):: copyfrom
            logical, intent(in), optional:: copyvalue
            logical, intent(in), optional:: overwrite
            logical, intent(out), optional:: err
        end subroutine
    end interface

    interface GTVarDel
        subroutine GTVarDel1(varname, err)
            character(len = *), intent(in):: varname
            logical, intent(out):: err
        end subroutine
    end interface

    !
    ! --- ¤δط ---
    !

    interface add_member
        subroutine GTVarAddMember(var, url, link_name)
            use gtdata_types, only: GT_VARIABLE
            use dc_string, only: VSTRING
            type(GT_VARIABLE), intent(inout):: var
            character(len = *), intent(in):: url
            character(len = *), intent(in), optional:: link_name
        end subroutine
    end interface

    ! դѿ̾μư
    interface 
        subroutine GTDataTmpNam(file, base, result)
            character(len = *), intent(in):: file
            character(len = *), intent(in):: base
            character(len = *), intent(out):: result
        end subroutine
    end interface


end module
